unit mainu;

// Copyright  2001 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, ShellCtrls, TeEngine, Tecanvas,
  Series, ExtCtrls, TeeProcs, Chart, dpobj, dpShare, ImgList,
  ActnList, AppEvnts, Menus, ComCtrls, ToolWin, StdCtrls;

type
  TMainform = class(TForm)
    alMain             : TActionList;
      // File actions
        acOpenEx         : TAction;
        acRefresh        : TAction;
        acCalcSize       : TAction;
        acPrint          : TAction;
        acClose          : TAction;
      // Navigation actions
        acExpView        : TAction;
        acFolderPie      : TAction;
        acSubPie         : TAction;
        acTypePie        : TAction;
        acParent         : TAction;
        acStop           : TAction;
      // Pie actions
        acPieCustom      : TAction;
        acPieScroll      : TAction;
        acFolScroll      : TAction;
        acTypScroll      : TAction;
        acPieDetail      : TAction;
        acPieLargest     : TAction;
    mmMain               : TMainMenu;
      topFile            : TMenuItem;
        mnuOpenEx        : TMenuItem;
        mnuRefresh       : TMenuItem;
        mnuCalcSize      : TMenuItem;
        mnuPrint         : TMenuItem;
        mnuClose         : TMenuItem;
      topGo              : TMenuItem;
        mnuExpView       : TMenuItem;
        mnuFolPie        : TMenuItem;
        mnuTypPie        : TMenuItem;
        mnuParent        : TMenuItem;
        mnuStop          : TMenuItem;
      topPie             : TMenuItem;
        mnuCustomize     : TMenuItem;
        mnuScrollbars    : TMenuItem;
        mnuDetail        : TMenuItem;
        mnuLargest       : TMenuItem;
      topHelp            : TMenuItem;
        mnuHelp          : TMenuItem;
        mnuAbout         : TMenuItem;
    tbMain               : TToolBar;
      tbRefresh          : TToolButton;
      tbPrint            : TToolButton;
      tbClose            : TToolButton;
      tbFolPie           : TToolButton;
      tbTypPie           : TToolButton;
      tbExpView          : TToolButton;
      tbParent           : TToolButton;
      tbStop             : TToolButton;
    pmExpView            : TPopupMenu;
      popExpFolPie       : TMenuItem;
      popExpTypPie       : TMenuItem;
      popExpCalcSize     : TMenuItem;
      popExpLargest      : TMenuItem;
      popExpOpenEx       : TMenuItem;
    pmFolder             : TPopupMenu;
      popFolOpt          : TMenuItem;
      popFolScroll       : TMenuItem;
      popFolSubPie       : TMenuItem;
      popFolExpView      : TMenuItem;
      popFolTypPie       : TMenuItem;
      popFolDetail       : TMenuItem;
      popFolLargest      : TMenuItem;
    pmTypes              : TPopupMenu;
      popTypOpt          : TMenuItem;
      popTypScroll       : TMenuItem;
      popTypExpView      : TMenuItem;
      popTypFolPie       : TMenuItem;
      popTypDetail       : TMenuItem;
      popTypLargest      : TMenuItem;
    pnlAddress           : TPanel;
      Label1             : TLabel;
      ebAddress          : TEdit;
    pcMain               : TPageControl;
      tsExplorer         : TTabSheet;
        ssTree           : TShellTreeView;
      tsFolderPie        : TTabSheet;
        chFolders        : TChart;
          serFol         : TPieSeries;
        sbXOffF          : TScrollBar;
        sbZoomF          : TScrollBar;
        sbYOffF          : TScrollBar;
        sbRotateF        : TScrollBar;
      tsFilePie          : TTabSheet;
        chTypes          : TChart;
          serTyp         : TPieSeries;
        sbZoomT          : TScrollBar;
        sbYOffT          : TScrollBar;
        sbXOffT          : TScrollBar;
        sbRotateT        : TScrollBar;
    sbMain               : TStatusBar;
    ilMain               : TImageList;
    pd1                  : TPrintDialog;
    tmrFol               : TTimer;
    tmrTyp               : TTimer;
    aeMain               : TApplicationEvents;
    // Useless separators
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    tbSep1 : TToolButton;
    tbSep2 : TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormResize(Sender: TObject);
    procedure acRefreshUpdate(Sender: TObject);
    procedure acRefreshExecute(Sender: TObject);
    procedure acOpenExExecute(Sender: TObject);
    procedure acCalcSizeExecute(Sender: TObject);
    procedure acPrintExecute(Sender: TObject);
    procedure acCloseExecute(Sender: TObject);
    procedure acFolderPieUpdate(Sender: TObject);
    procedure acExpViewExecute(Sender: TObject);
    procedure acFolderPieExecute(Sender: TObject);
    procedure acTypePieExecute(Sender: TObject);
    procedure acSubPieExecute(Sender: TObject);
    procedure acParentExecute(Sender: TObject);
    procedure acStopExecute(Sender: TObject);
    procedure acPieCustomUpdate(Sender: TObject);
    procedure acPieCustomExecute(Sender: TObject);
    procedure acTypScrollExecute(Sender: TObject);
    procedure acFolScrollExecute(Sender: TObject);
    procedure acPieScrollExecute(Sender: TObject);
    procedure acPieDetailExecute(Sender: TObject);
    procedure acPieLargestExecute(Sender: TObject);
    procedure topPieClick(Sender: TObject);
    procedure mnuHelpClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure pmFolderPopup(Sender: TObject);
    procedure pmTypesPopup(Sender: TObject);
    procedure ebAddressKeyPress(Sender: TObject; var Key: Char);
    procedure pcMainChange(Sender: TObject);
    procedure pcMainChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure ssTreeChange(Sender: TObject; Node: TTreeNode);
    procedure ssTreeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure chFoldersMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure chFoldersResize(Sender: TObject);
    procedure sbZoomFChange(Sender: TObject);
    procedure sbXOffFChange(Sender: TObject);
    procedure sbYOffFChange(Sender: TObject);
    procedure sbRotateFChange(Sender: TObject);
    procedure chTypesResize(Sender: TObject);
    procedure sbZoomTChange(Sender: TObject);
    procedure sbYOffTChange(Sender: TObject);
    procedure sbXOffTChange(Sender: TObject);
    procedure sbRotateTChange(Sender: TObject);
    procedure tmrBothTimer(Sender: TObject);
    procedure aeMainHint(Sender: TObject);
    procedure aeMainIdle(Sender: TObject; var Done: Boolean);
  private
    { Private declarations }
    folXtra    : TChartExtra; // extra data for folder pie
    typXtra    : TChartExtra; // extra data for type pie
    clickedpie : String;      // name of clicked folder-pie slice
    TDT        : TDPTree;     // holder for gathered folder-size data
    CustomMsg  : Cardinal;    // to communicate with other instances
    Busy       : Boolean;     // True when program is busy
    procedure InitPie(First : Boolean; C : TChart;
      VAR pieXtra : TChartExtra);
    procedure SavePie(C : TChart; const pieXtra : TChartExtra);
    procedure BakeFolderPie(const fName : String);
    procedure BakeTypePie(const fName : String);
    function CanPie(const S : String) : Boolean;
    function CanPieParent(const S : String) : Boolean;
    procedure SetTheTitle(C : TChart; const S : String);
    procedure SetBusy(Value : Boolean);
    procedure TopEllipse(C : TChart; VAR Rgn : HRgn);
  public
    { Public declarations }
    procedure ListToSeries(SL, SC : TStrings; SR : TPieSeries;
      slices :Integer);
    procedure DefaultHandler(var Message); override;
  end;

var
  Mainform: TMainform;

implementation
uses printers, filectrl, allfuncs, Registry, chartoptu, inifiles,
  AboutBox, formposu, detailu;

{$R *.dfm}
function Min(A, B : Int64) : Int64;
begin
  IF A < B THEN Result := A ELSE Result := B;
end;

procedure TMainform.FormCreate(Sender: TObject);
  procedure DoImageList;
  // Shell version differences can cause a pre-loaded imagelist to
  // come up empty. We load the images at run time to avoid this
  VAR
    N : Integer;
    TB : TBitmap;
  begin
    ilMain.Clear;
    TB := TBItmap.Create;
    try
      FOR N := 2 TO 12 DO
        begin
          TB.LoadFromResourceID(hInstance, N);
          ilMain.AddMasked(TB, clFuchsia);
        end;
    finally
      TB.Free;
    end;
  end;

  // For version 2.1, ininame is changed to a function. This avoids a
  // mysterious problem on a few systems where the variable ininame
  // would get corrupted, with its 6th character changed to a
  // nonprintable character
  //2.1
(*  procedure GetIniName;
  VAR
    D : DWord;
    buffer : ARRAY[0..MAX_PATH] OF Char;
  begin
    ininame := '';
    D := MAX_PATH;
    IF NOT GetUserName(buffer, D) THEN
      StrCopy(buffer, 'User');
    ininame := Format('%s\DiskPie %s.INI',
      [ExtractFileDir(Application.Exename), buffer]);
  end;*)

  procedure LoadExtras;
  begin
    folXtra.dList    := TStringList.Create;
    typXtra.dList    := TStringList.Create;
    typXtra.dFilList := TStringList.Create;
    folXtra.dFilList := TStringList.Create;
    folXtra.dTitle   := '';
    typXtra.dTitle   := '';
    folXtra.dSec     := 'Folder settings';
    typXtra.dSec     := 'File type settings';
    folXtra.dCols    := TStringList.Create;
    typXtra.dCols    := TStringList.Create;
    folXtra.dRgn     := 0;
    typXtra.dRgn     := 0;
  end;

  procedure FromExtras;
  begin
    acFolScroll.Checked := folXtra.dScroll;
    sbZoomF.Visible     := acFolScroll.Checked;
    sbRotateF.Visible   := acFolScroll.Checked;
    sbXOffF.Visible     := acFolScroll.Checked;
    sbYOffF.Visible     := acFolScroll.Checked;
    acTypScroll.Checked := typXtra.dScroll;
    sbZoomT.Visible     := acTypScroll.Checked;
    sbRotateT.Visible   := acTypScroll.Checked;
    sbXOffT.Visible     := acTypScroll.Checked;
    sbYOffT.Visible     := acTypScroll.Checked;
  end;

begin
  DoImageList;
  pcMain.ActivePageIndex := 0;
//2.1  GetIniName;
  GetPosFmIni(Ininame, Self, True);
  CustomMsg := RegisterWindowMessage('PC Magazine DiskPie 2 customize message');
  Application.HelpFile := ChangeFileExt(Application.Exename, '.HLP');
  TDT                  := TDPTree.Create;
  LoadExtras;
  InitPie(true, chFolders, folXtra);
  InitPie(true, chTypes, typXtra);
  FromExtras;
end;

procedure TMainform.FormDestroy(Sender: TObject);
begin
  SetPosToIni(Ininame, Self, True);
  WITH TIniFile.Create(ininame) DO
  try
    IF pos(':\', ssTree.Path) = 2 THEN
      WriteString('Settings', 'Start folder', ssTree.Path);
    WriteBool(folXtra.dSec, 'Scrollbars', acFolScroll.Checked);
    WriteBool(typXtra.dSec, 'Scrollbars', acTypScroll.Checked);
  finally
    Free;
  end;
end;

procedure TMainform.FormActivate(Sender: TObject);
VAR S : String;
begin
  Show;
  Application.ProcessMessages;
  IF ParamCount > 0 THEN
    S := ParamStr(1)
  ELSE
    WITH TIniFile.Create(ininame) DO
    try
      S := ReadString('Settings', 'Start folder', 'C:\');
    finally
      Free;
    end;
  IF NOT DirectoryExists(S) THEN S := 'C:\';
  ssTree.Path    := S;
  ssTree.Enabled := True;
end;

procedure TMainform.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := NOT Busy;
  IF Busy THEN
    MessageBox(Handle, 'Before closing the program, please either '+
      'cancel the current operation or allow it to finish.',
      'DiskPie', MB_OK OR MB_ICONINFORMATION);
end;

procedure TMainform.FormMouseWheel(Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
// We want the mousewheel to affect whatever scrollbar is under the
// cursor. If none is, and the scrollbars are visible, we want
// it to ZOOM.  
VAR
  SB : TScrollBar;
  Pt : TPoint;
begin
  SB := nil;
  CASE pcMain.ActivePageIndex OF
    0 : Exit;
    1 : begin
      pt := tsFolderPie.ScreenToClient(MousePos);
      IF tsFolderPie.ControlAtPos(Pt, True, True) IS TScrollBar THEN
        SB := TScrollBar(tsFolderPie.ControlAtPos(Pt, True, True))
      ELSE SB := sbZoomF;
    end;
    2 : begin
      pt := tsFilePie.ScreenToClient(MousePos);
      IF tsFilePie.ControlAtPos(Pt, True, True) IS TScrollBar THEN
        SB := TScrollBar(tsFilePie.ControlAtPos(Pt, True, True))
      ELSE SB := sbZoomT;
    end;
  END;
  IF NOT (Assigned(SB) AND SB.Visible) THEN Exit;
  WITH SB DO
    IF (WheelDelta > 0) AND (Position < Max) THEN
      Position := Succ(Position)
    ELSE IF (WheelDelta <= 0) AND (Position > Min) THEN
      Position := Pred(Position);
  Handled := True;
end;

procedure TMainform.FormResize(Sender: TObject);
// The TChart's internal function for telling which slice the mouse
// is over is flawed - it reports on the BOTTOM of a 3D pie. To
// make it work on the TOP requires painful effort, including
// keeping track of the elliptical region that defines the top.
// When the form resizes, we adjust that region.
begin
  TopEllipse(chFolders, folXtra.dRgn);
  TopEllipse(chTypes, typXtra.dRgn);
end;

procedure TMainform.acRefreshUpdate(Sender: TObject);
begin
  // Parent folder is enabled if Explorer view is up, or if parent
  // is a file-system folder
  acParent.Enabled  := (NOT Busy) AND ((pcMain.ActivePageIndex = 0) OR
    CanPieParent(ssTree.Path));
  acRefresh.Enabled := (NOT Busy);
  acClose.Enabled   := (NOT Busy);
  // Print is enabled when a pie is visible
  acPrint.Enabled   := (NOT Busy) AND (
    ((pcMain.ActivePageIndex=1) AND (chFolders.Series[0].Count>0)) OR
    ((pcMain.ActivePageIndex=2) AND (chTypes.Series[0].Count>0)));
end;

procedure TMainform.acRefreshExecute(Sender: TObject);
begin
  // Discard the saved file size data
  TDT.Clear;
  // Refresh the tree
  ssTree.Refresh(TTreeView(ssTree).Items.GetFirstNode);
  // If a pie is visible, recreate it
  CASE pcMain.ActivePageIndex OF
    0 : ;
    1 : BakeFolderPie(ssTree.Path);
    2 : BakeTypePie(ssTree.Path);
  END;
end;

procedure TMainform.acOpenExExecute(Sender: TObject);
begin
  // It's easy to open in Explorer
  ssTree.SelectedFolder.ExecuteDefault;
end;

procedure TMainform.acCalcSizeExecute(Sender: TObject);
VAR TN : TDPNode;
begin
  IF CanPie(ssTree.Path) THEN
    begin
      SetBusy(True);
      try
        // Get the node for the specified path
        TN := TDT.NodeForPath(ssTree.Path);
        try
          IF TN = nil THEN Exit;
          // Expand all its subfolders
          TN.Expand;
          IF Halting THEN Exit;
          // Calculate the sizes
          TN.GetSize;
          IF Halting THEN Exit;
        finally
          // If the operation was interrupted, clear partial results
          IF Halting THEN
            TN.NoSize;
          Halting := False;
        end;
      finally
        SetBusy(False);
      end;
    end
  ELSE
    MessageBox(Self.Handle, 'Please select an actual file-system '+
      'folder first.', 'DiskPie', MB_OK OR MB_ICONSTOP);
end;

procedure TMainform.acPrintExecute(Sender: TObject);

  procedure DoPrint(C : TChart);
  VAR
    R         : TRect;
    wasLegend : Boolean;
    wasLabels : Boolean;
  begin
    // Get the page rectangle
    R := Rect(0, 0, Printer.PageWidth-1, Printer.PageHeight-1);
    // Shrink it by 5% all around
    InflateRect(R, -Round(Printer.PageWidth/20),
      -Round(Printer.PageHeight/20));
    // Remember current label/legend status, then turn off both
    // and hide the title (Title is on detail page)
    wasLegend := C.Series[0].ShowInLegend;
    wasLabels := C.Series[0].Marks.Visible;
    C.Series[0].ShowInLegend  := False;
    C.Series[0].Marks.Visible := False;
    C.Title.Visible           := False;
    Screen.Cursor             := crHourglass;
    try
      C.PrintRect(R);
    finally
      // Restore settings that were changed for printing
      C.Series[0].ShowInLegend  := wasLegend;
      C.Series[0].Marks.Visible := WasLabels;
      Screen.Cursor             := crDefault;
      C.Title.Visible           := True;
    end;
  end;

begin
  CASE pcMain.ActivePageIndex OF
    0 : ;
    1 : IF pd1.Execute THEN
      begin
        SetBusy(True);
        DetailForm.SetData(0, folXtra);
        DetailForm.RE.Print(Self.Caption);
        DoPrint(chFolders);
        SetBusy(False);
      end;
    2 : IF pd1.Execute THEN
      begin
        SetBusy(True);
        DetailForm.SetData(1, typXtra);
        DetailForm.RE.Print(Self.Caption);
        DoPrint(chTypes);
        SetBusy(False);
      end;
  END;
end;

procedure TMainform.acCloseExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainform.acFolderPieUpdate(Sender: TObject);
VAR TN : TDPNode;
begin
  acStop.Enabled := Busy;
  CASE pcMain.ActivePageIndex OF
    0 : begin // Explorer view tab
      // Can't go to Explorer view - we're there
      acExpView.Enabled   := False;
      // Call CanPie() to see if we can bake a pie
      acFolderPie.Enabled := (NOT Busy) AND CanPie(ssTree.Path);
      acTypePie.Enabled   := acFolderPie.Enabled;
      // If folder is pie-possible, check whether its sizes have been
      // calculated. Enable "Calculate folder size" if NOT.
      IF acFolderPie.Enabled THEN
        begin
          TN := TDT.NodeForPath(ssTree.Path);
          acCalcSize.Enabled := (TN <> nil) AND (TN.AvailSize < 0);
        end
      ELSE acCalcSize.Enabled := False;
    end;
    1 : begin
      acExpView.Enabled   := (NOT Busy);
      acFolderPie.Enabled := False;
      acTypePie.Enabled   := (NOT Busy);
      acCalcSize.Enabled  := False;
    end;
    2 : begin
      acExpView.Enabled   := (NOT Busy);
      acFolderPie.Enabled := (NOT Busy);
      acTypePie.Enabled   := False;
      acCalcSize.Enabled  := False;
    end;
  END;
end;

procedure TMainform.acExpViewExecute(Sender: TObject);
begin
  // If Explorer view was selected by right-clicking a slice, and it
  // corresponds to a file-system folder, switch to that folder.
  IF (pcMain.ActivePageIndex = 1) AND (clickedPie <> '"Other"') AND
    (clickedPie <> '"In folder"') AND (clickedPie <> '') THEN
      ssTree.Path := NoFinalSlash(folXtra.dTitle) + '\' + clickedpie;
  pcMain.ActivePageIndex := 0;
end;

procedure TMainform.acFolderPieExecute(Sender: TObject);
begin
  pcMain.ActivePageIndex := 1;
  pcMainChange(pcMain);
end;

procedure TMainform.acTypePieExecute(Sender: TObject);
begin
  // If File type pie was selected by right-clicking a slice, and it
  // corresponds to a file-system folder, switch to that folder.
  IF (pcMain.ActivePageIndex = 1) AND (clickedPie <> '"Other"') AND
    (clickedPie <> '"In folder"') THEN
    ssTree.Path := NoFinalSlash(folXtra.dTitle) + '\' + clickedpie;
  pcmain.ActivePageIndex := 2;
  pcMainChange(pcMain);
end;

procedure TMainform.acSubPieExecute(Sender: TObject);
begin
  IF clickedpie = '' THEN Exit;
  IF clickedpie = '"Other"' THEN Exit;
  IF clickedpie = '"In folder"' THEN Exit;
  ssTree.Path := NoFinalSlash(folXtra.dTitle) + '\' + clickedpie;
  BakeFolderPie(ssTree.Path);
end;

procedure TMainform.acParentExecute(Sender: TObject);
// Switch to the parent of the current folder
begin
  IF (pcMain.ActivePageIndex > 0) AND
    (NOT CanPieParent(ssTree.Path)) THEN Exit;
  ssTree.Selected := ssTree.Selected.Parent;
  CASE pcMain.ActivePageIndex OF
    0 : ;
    1 : BakeFolderPie(ssTree.Path);
    2 : BakeTypePie(ssTree.Path);
  END;
end;

procedure TMainform.acStopExecute(Sender: TObject);
// Simple-minded stop-process - set a global variable to true
begin
  Halting := True;
end;

procedure TMainform.acPieCustomUpdate(Sender: TObject);
VAR TN : TDPNode;
begin
  // Customize is enabled if either pie is showing
  acPieCustom.Enabled  := (NOT Busy) AND
    (pcMain.ActivePageIndex <> 0);
  // Detail is enabled if the visible pie is non-empty
  acPieDetail.Enabled  := (NOT Busy) AND
    (((pcMain.ActivePageIndex =1) AND (folXtra.dList.Count > 0)) OR
    ((pcMain.ActivePageIndex = 2) AND (typXtra.dList.Count > 0)));
  // Largest is enabled if the visible pie is non-empty, or if the
  // visible selected folder has been calculated as non-empty
  IF (NOT Busy) THEN
    CASE pcMain.ActivePageIndex OF
      0 : begin
        TN := TDT.NodeForPath(ssTree.Path);
        acPieLargest.Enabled := (TN <> nil) AND (TN.AvailSize > 0);
      end;
      1 : acPieLargest.Enabled := folXtra.dFilList.Count > 0;
      2 : acPieLargest.Enabled := typXtra.dFilList.Count > 0;
    END
  ELSE acPieLargest.Enabled := False;
  acFolScroll.Enabled  := (NOT Busy) AND (pcMain.ActivePageIndex = 1);
  acTypScroll.Enabled  := (NOT Busy) AND (pcMain.ActivePageIndex = 2);
  acPieScroll.Enabled  := (NOT Busy) AND (pcMain.ActivePageIndex > 0);
end;

procedure TMainform.acPieCustomExecute(Sender: TObject);
// The Customize dialog acts directly on the specified chart in real
// time. If the user cancels, the dialog puts everything back the
// way it was.
VAR Changed : Boolean;
begin
  CASE pcMain.ActivePageIndex OF
    1 : begin
      WITH TOptForm.Create(Self) DO
      try
        SetData(chFolders, folXtra, 'Customize folder pie');
        Changed := ShowModal <> mrCancel;
        GetData(folXtra);
        // Save the extra chart information
        folXtra.dCircled := TPieSeries(chFolders.Series[0]).Circled;
        folXtra.dLabels  :=
          TPieSeries(chFolders.Series[0]).Marks.Visible;
        folXtra.dElev    := chFolders.View3dOptions.Elevation;
        folXtra.dScroll  := acFolScroll.Checked;
        // If changes were made, save them to the INI file and send
        // a message telling any other instances of DiskPie to load
        // the changed settings.
        IF Changed THEN
          begin
            SavePie(chFolders, folXtra);
            SendMessage(HWND_BROADCAST, CustomMsg, Self.Handle, 1);
            TopEllipse(chFolders, folXtra.dRgn);
          end;
      finally
        Free;
      end;
    end;
    2 : begin
      WITH TOptForm.Create(Self) DO
      try
        SetData(chTypes, typXtra, 'Customize file type pie');
        Changed := ShowModal <> mrCancel;
        GetData(typXtra);
        typXtra.dCircled := TPieSeries(chTypes.Series[0]).Circled;
        typXtra.dLabels  :=
          TPieSeries(chTypes.Series[0]).Marks.Visible;
        typXtra.dElev    := chTypes.View3dOptions.Elevation;
        typXtra.dScroll  := acTypScroll.Checked;
        IF Changed THEN
          begin
            SavePie(chTypes, typXtra);
            SendMessage(HWND_BROADCAST, CustomMsg, Self.Handle, 2);
            TopEllipse(chTypes, typXtra.dRgn);
          end;
      finally
        Free;
      end;
    end;
  END;
end;

procedure TMainform.acTypScrollExecute(Sender: TObject);
begin
  WITH acTypScroll DO Checked := NOT Checked;
  sbZoomT.Visible   := acTypScroll.Checked;
  sbRotateT.Visible := acTypScroll.Checked;
  sbXOffT.Visible   := acTypScroll.Checked;
  sbYOffT.Visible   := acTypScroll.Checked;
  // If the scrollbars are not visible, restore the settings they
  // control to default values
  IF NOT acTypScroll.Checked THEN
    WITH chTypes DO
      begin
        View3DOptions.HorizOffset           := 0;
        View3DOptions.VertOffset            := 0;
        View3DOptions.Zoom                  := 100;
        TPieSeries(Series[0]).RotationAngle := 0;
        sbZoomT.Position                    := 0;
        sbRotateT.Position                  := 0;
        sbXOffT.Position                    := 0;
        sbYOffT.Position                    := 0;
      end;
  TopEllipse(chTypes, typXtra.dRgn);
end;

procedure TMainform.acFolScrollExecute(Sender: TObject);
begin
  WITH acFolScroll DO Checked := NOT Checked;
  sbZoomF.Visible   := acFolScroll.Checked;
  sbRotateF.Visible := acFolScroll.Checked;
  sbXOffF.Visible   := acFolScroll.Checked;
  sbYOffF.Visible   := acFolScroll.Checked;
  // If the scrollbars are not visible, restore the settings they
  // control to default values
  IF NOT acFolScroll.Checked THEN
    WITH chFolders DO
      begin
        View3DOptions.HorizOffset           := 0;
        View3DOptions.VertOffset            := 0;
        View3DOptions.Zoom                  := 100;
        TPieSeries(Series[0]).RotationAngle := 0;
        sbZoomF.Position                    := 0;
        sbRotateF.Position                  := 0;
        sbXOffF.Position                    := 0;
        sbYOffF.Position                    := 0;
      end;
  TopEllipse(chFolders, folXtra.dRgn);
end;

procedure TMainform.acPieScrollExecute(Sender: TObject);
// This action exists strictly to handle the top-level Pie menu's
// Scrollbars item. It modifies one or the other set of scroolbars
// depending on which pie is visible
begin
  CASE pcMain.ActivePageIndex OF
    1 : begin
      WITH Sender AS TAction DO Checked := NOT Checked;
      acFolScrollExecute(acFolScroll);
    end;
    2 : begin
      WITH Sender AS TAction DO Checked := NOT Checked;
      acTypScrollExecute(acTypScroll);
    end;
  END;
end;

procedure TMainform.acPieDetailExecute(Sender: TObject);
begin
  WITH DetailForm DO
    begin
      CASE Self.pcMain.ActivePageIndex OF
        0 : Exit;
        1 : SetData(0, folXtra);
        2 : SetData(1, typXtra);
      end;
      ShowModal;
    end;
end;

procedure TMainform.acPieLargestExecute(Sender: TObject);
VAR TN : TDPNode;
begin
  WITH DetailForm DO
    CASE pcMain.ActivePageIndex OF
      0 : begin
        TN := TDT.NodeForPath(ssTree.Path);
        IF TN = nil THEN Exit;
        IF TN.AvailSize < 0 THEN Exit;
        TN.LargestFiles(folXtra.dFilList);
        SetData(2, folXtra.dFilList, nil, uttermax,
          ssTree.SelectedFolder.Pathname);
        ShowModal;
      end;
      1 : begin
        SetData(2, folXtra.dFilList, nil, uttermax, folXtra.dTitle);
        ShowModal;
      end;
      2 : begin
        SetData(2, typXtra.dFilList, nil, uttermax, typXtra.dTitle);
        ShowModal;
      end;
    END;
end;

procedure TMainform.topPieClick(Sender: TObject);
begin
  CASE pcMain.ActivePageIndex OF
    1 : acPieScroll.Checked := acFolScroll.Checked;
    2 : acPieScroll.Checked := acTypScroll.Checked;
  END;
end;

procedure TMainform.mnuHelpClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
end;

procedure TMainform.mnuAboutClick(Sender: TObject);
begin
  Application.Title := 'DiskPie';
  WITH TAboutForm.Create(Self) DO
  try
    ShowModal;
  finally
    Free;
    Application.Title := 'Diskpie - ' + ebAddress.Text;
  end;
end;

procedure TMainform.pmFolderPopup(Sender: TObject);
// Ensure that the menu items are updated
begin
  acFolderPieUpdate(acFolderPie);
end;

procedure TMainform.pmTypesPopup(Sender: TObject);
begin
// Ensure that the menu items are updated
  acFolderPieUpdate(acFolderPie);
end;

procedure TMainform.ebAddressKeyPress(Sender: TObject; var Key: Char);
VAR Was : String;
begin
  IF Key = #13 THEN
    begin
      Key := #0;
      try
        Was := ssTree.Path;
        ssTree.Path := ebAddress.Text;
        IF ssTree.Selected = nil THEN
          begin
            ebAddress.Text := Was;
            MessageBeep(MB_ICONSTOP);
            Exit;
          end;
      except
        ON Exception DO
          begin
            ebAddress.Text := Was;
            MessageBeep(MB_ICONSTOP);
            Exit;
          end
      end;
      CASE pcMain.ActivePageIndex OF
        1 : BakeFolderPie(
              TShellFolder(ssTree.Selected.Data).PathName);
        2 : BakeTypePie(
              TShellFolder(ssTree.Selected.Data).PathName);
      END;
    end;
end;

procedure TMainform.pcMainChange(Sender: TObject);
begin
  CASE pcMain.ActivePageIndex OF
    1 : IF folXtra.dTitle <> ssTree.Path THEN
          BakeFolderPie(ssTree.Path);
    2 : IF typXtra.dTitle <> ssTree.Path THEN
          BakeTypePie(ssTree.Path);
  END;
end;

procedure TMainform.pcMainChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  IF Busy THEN AllowChange := False
  ELSE IF pcMain.ActivePageIndex = 0 THEN
    IF CanPie(ebAddress.Text) THEN
      AllowChange := True
    ELSE
      begin
        AllowChange := False;
        MessageBox(Self.Handle, 'Please select an actual '+
          'file-system folder first.', 'DiskPie',
          MB_OK OR MB_ICONSTOP);
      end
  ELSE AllowChange := True;
end;

procedure TMainform.ssTreeChange(Sender: TObject; Node: TTreeNode);
VAR TN : TDPNode;
begin
  // Occasionally a change to a network drive will come in with
  // Node set to nil - we must ignore this
  IF Node = nil THEN
    Exit;
  ebAddress.Text    := TShellFolder(Node.data).Pathname;
  self.Caption      := 'Diskpie - ' + ebAddress.Text;
  Application.Title := Self.Caption;
  IF NOT Assigned(TDT) THEN Exit;
  TN := TDT.NodeForPath(TShellFolder(Node.data).Pathname);
  IF (TN <> nil) AND (TN.AvailSize > 0) THEN
    begin
      sbMain.Panels[1].Text := StringForBytes(TN.AvailSize);
      sbMain.Panels[2].Text := Format('%d files in and below "%s"',
        [TN.FileCount, TN.Name]);
    end
  ELSE
    begin
      sbMain.Panels[1].Text := '';
      sbMain.Panels[2].Text := '';
    end;
end;

procedure TMainform.ssTreeMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
VAR TN : TTreeNode;
begin
  IF Button <> mbRight THEN Exit;
  WITH ssTree DO
    begin
      WITH ScreenToClient(Point(X,Y)) DO
        TN := GetNodeAt(X, Y);
      IF TN = nil THEN Exit;
      Selected := TN;
    end;
  pmExpView.Popup(X, Y);
end;

procedure TMainform.chFoldersMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
// Figuring out which pie slice is under the mouse can be maddening.
// The built-in CalcClickedPart() method gives wrong results in a
// 3D pie - it calculates based on the BOTTOM of the pie. Beta
// tester Bruno Sonnino supplied the CorrectIndex function to
// calculate based on the pie's top. Even this needed further
// tweaking, as certain positions on the pie's edge would get
// the wrong result.
VAR
  TCP : TChartClickedPart;
  TP : TPieSeries;
  Idx : Integer;
  Sum : Extended;

  function CorrectIndex : Integer;
  // Thanks to beta tester Bruno Sonnino
  VAR
    tmpAngle : Double;
    C        : TChart;
  begin
    C := (Sender AS TChart);
    C.Canvas.Calculate2DPosition(X, Y, C.Width3D);
    WITH TP DO
      begin
        tmpAngle := PointToAngle(X, Y);
        FOR Result := 0 TO Count-1 DO
          begin
//            IF (Abs(X-CircleXCenter)<(XRadius)) AND
//               (Abs(Y-CircleYCenter)<(YRadius)) then
              WITH Angles[Result] DO
                IF (tmpAngle>=StartAngle) AND
                   (tmpAngle<=EndAngle) THEN
                  Exit;
        end;
      Result := -1;
    end;
  end;

begin
  IF Sender = chFolders THEN clickedPie := '';
  sbMain.Panels[0].Text := '';
  sbMain.Panels[1].Text := '';
  sbMain.Panels[2].Text := '';
  // If we're busy, clear the status bar and quit
  IF Busy THEN Exit;
  // Set up the status bar panels to reflect the size of the
  // entire pie. If the mouse is actually over a slice, legend,
  // or label, these will be replaced.
  TP  := TPieSeries((Sender AS TChart).Series[0]);
  //!!!
  Sum := 0;
  FOR Idx := 0 TO TP.Count-1 DO
    Sum := Sum + TP.PieValues[Idx];
  sbMain.Panels[0].Text := StringForBytes(Round(Sum));
  sbMain.Panels[1].Text := '100%';
  sbMain.Panels[2].Text := '(entire pie)';
  // The program maintains an elliptical region that matches the
  // top of each pie. If the mouse is within this region, call
  // the CorrectIndex function to figure out which slice.
  IF ((Sender = chFolders) AND
    (PtInRegion(folXtra.dRgn, X, Y))) OR
     ((Sender = chTypes) AND
    (PtInRegion(typXtra.dRgn, X, Y))) THEN
    begin
      Idx := CorrectIndex;
    end
  ELSE
    begin
      // If the mouse is not on a slice, we can use the TChart's
      // CalcClickedPart() method to see where it is
      (Sender AS TChart).CalcClickedPart(Point(X, Y), TCP);
      IF TCP.PointIndex >= (Sender AS TChart).Series[0].Count THEN
        Exit;
      IF TCP.Part = cpLegend THEN
         Idx := TCP.PointIndex
      ELSE Exit;
    end;
  IF Idx = -1 THEN Exit;  
  sbMain.Panels[0].Text :=
    StringForBytes(Round(TP.PieValues[Idx]));
  sbMain.Panels[1].Text :=
    TP.MarkPercent(Idx, False);
  IF Sender = chFolders THEN
    begin
      sbMain.Panels[2].Text:= TP.XLabel[Idx];
      clickedPie := TP.XLabel[Idx];
    end
  ELSE
    sbMain.Panels[2].Text:=
      TDPTypeObj.AssnName(TP.XLabel[Idx]);
end;

procedure TMainform.chFoldersResize(Sender: TObject);
// The title may be too wide, especially if the pathname is long
// and the font is large. Our SetTheTitle function replaces
// parts of the path with ellipses if necessary
begin
  SetTheTitle(chFolders, folXtra.dTitle);
end;

procedure TMainform.sbZoomFChange(Sender: TObject);
begin
  chFolders.View3DOptions.Zoom := 100 + 10*sbZoomF.Position;
  chFolders.View3DOptions.HorizOffset :=
    (chFolders.View3DOptions.Zoom*(sbXOffF.Position)) DIV 20;
  chFolders.View3DOptions.VertOffset :=
    (chFolders.View3DOptions.Zoom*(sbYOffF.Position)) DIV 20;
  TopEllipse(chFolders, folXtra.dRgn);
  sbZoomF.Hint := Format(fmtZoom, [100+10*sbZoomF.Position]);
  sbMain.Panels[2].Text := GetLongHint(sbZoomF.Hint);
end;

procedure TMainform.sbXOffFChange(Sender: TObject);
begin
  chFolders.View3DOptions.HorizOffset :=
    (chFolders.View3DOptions.Zoom*(sbXOffF.Position)) DIV 20;
  TopEllipse(chFolders, folXtra.dRgn);
end;

procedure TMainform.sbYOffFChange(Sender: TObject);
begin
  chFolders.View3DOptions.VertOffset :=
    (chFolders.View3DOptions.Zoom*(sbYOffF.Position)) DIV 20;
  TopEllipse(chFolders, folXtra.dRgn);
end;

procedure TMainform.sbRotateFChange(Sender: TObject);
begin
  TPieSeries(chFolders.Series[0]).RotationAngle := sbRotateF.Position*5;
  WITH Sender AS TScrollBar DO
    begin
      Hint := Format(fmtRotate, [Position*5]);
      sbMain.Panels[2].Text := GetLongHint(Hint);
    end;
end;

procedure TMainform.chTypesResize(Sender: TObject);
begin
  SetTheTitle(chTypes, typXtra.dTitle);
end;

procedure TMainform.sbZoomTChange(Sender: TObject);
begin
  chTypes.View3DOptions.Zoom := 100 + 10*sbZoomT.Position;
  chTypes.View3DOptions.HorizOffset :=
    (chTypes.View3DOptions.Zoom*(sbXOffT.Position)) DIV 20;
  chTypes.View3DOptions.VertOffset :=
    (chTypes.View3DOptions.Zoom*(sbYOffT.Position)) DIV 20;
  TopEllipse(chTypes, typXtra.dRgn);
  sbZoomT.Hint := Format(fmtZoom, [100+10*sbZoomT.Position]);
  sbMain.Panels[2].Text := GetLongHint(sbZoomT.Hint);
end;

procedure TMainform.sbYOffTChange(Sender: TObject);
begin
  chTypes.View3DOptions.VertOffset :=
    (chTypes.View3DOptions.Zoom*(sbYOffT.Position)) DIV 20;
  TopEllipse(chTypes, typXtra.dRgn);
end;

procedure TMainform.sbXOffTChange(Sender: TObject);
begin
  chTypes.View3DOptions.HorizOffset :=
    (chTypes.View3DOptions.Zoom*(sbXOffT.Position)) DIV 20;
  TopEllipse(chTypes, typXtra.dRgn);
end;

procedure TMainform.sbRotateTChange(Sender: TObject);
begin
  TPieSeries(chTypes.Series[0]).RotationAngle := sbRotateT.Position*5;
  WITH Sender AS TScrollBar DO
    begin
      Hint := Format(fmtRotate, [Position*5]);
      sbMain.Panels[2].Text := GetLongHint(Hint);
    end;
end;

procedure TMainform.tmrBothTimer(Sender: TObject);
// While waiting for pie data, DiskPie sweeps a line around the
// pie display, a bit like a clock's second hand. This routine
// handles that task.
VAR
  I : Integer;
  C : TChart;
begin
  // Version 2.1 modification
  // On very slow systems, the pie-rotation took SO long that the
  // actual disk analysis never got a chance. In this version, we
  // disable the timer at the start and re-enable it at the end.
  // That way the background process always gets the full timer
  // interval to do its work. I also increased the interval from
  // 200 to 400 ms.
  (Sender AS TTimer).Enabled := False;
  IF Sender = tmrFol THEN
    C := chFolders
  ELSE C := chTypes;
  I := TPieSeries(C.Series[0]).RotationAngle - 1;
  IF I < 0 THEN I := 359;
  TPieSeries(C.Series[0]).RotationAngle := I;
  C.Refresh;
  WITH Sender AS TTImer DO
    Enabled := Tag > 0;
end;

procedure TMainform.aeMainHint(Sender: TObject);
begin
  sbMain.Panels[2].Text := Application.Hint;
  sbMain.Panels[1].Text := '';
  sbMain.Panels[0].Text := '';
end;

procedure TMainform.aeMainIdle(Sender: TObject; var Done: Boolean);
// We can't just check whether to display size data when the current
// folder changes, as it may become available without a change.
// Instead, we do it in OnIdle, which is called once each time
// the program finishes all its current business.
VAR TN : TDPNode;
begin
  IF pcMain.ActivePageIndex <> 0 THEN Exit;
  IF Application.Hint <> '' THEN Exit;
  IF Screen.ActiveForm <> Self THEN Exit;
  TN := TDT.NodeForPath(ssTree.Path);
  IF (TN <> nil) AND (TN.AvailSize > 0) THEN
    begin
      sbMain.Panels[1].Text := StringForBytes(TN.AvailSize);
      sbMain.Panels[2].Text := Format('%d files in and below "%s"',
        [TN.FileCount, TN.Name]);
    end;
end;

procedure TMainForm.InitPie(first : Boolean; C : TChart;
  VAR pieXtra : TChartExtra);
VAR
  fSR : TPieSeries;
  N   : Integer;
  Col : Integer;
begin
  WITH pieXtra DO
    begin
      WITH TIniFile.Create(ininame) DO
      try
        dBak := ReadInteger(dSec, 'Background Style', 1);
        dImage := ReadString(dSec, 'BackImage file', '');
        IF NOT FileExists(dImage) THEN dImage := '';
        IF (dImage <> '') AND (dBak = 2) THEN
          try
            C.BackImage.LoadFromFile(dImage);
          except
            ON Exception DO
              begin
                dImage := '';
                dBak := 1;
              end;
          end;
        IF dBak <> 2 THEN
          C.BackImage.Bitmap.Handle := 0;
        C.Title.Font.Name := ReadString(dSec+' font','Name','Arial');
        C.Title.Font.Size := ReadInteger(dSec+' font', 'Size', 12);
        C.Title.Font.Style := TFontStyles(Byte(
          ReadInteger(dSec+' font', 'Style', 0)));
        C.Title.Font.Color := TColor(ReadInteger(dSec+' font',
          'Color', Integer(clBlack)));
        C.Foot.Font := C.Title.Font;
        dCircled := ReadBool(dSec, 'Circled pie', False);
        C.View3D := ReadBool(dSec, '3D pie', True);
        dLabels := ReadBool(dSec, 'Labels', False);
        dScroll := ReadBool(dSec, 'Scrollbars', False);
        C.Legend.Visible := ReadBool(dSec, 'Legend', True);
        C.View3DOptions.Elevation := ReadInteger(dSec,
          '3D elevation', 340);
        dElev := C.View3DOptions.Elevation;
        dSlices := ReadInteger(dSec, 'Slices', 16);
        C.Chart3DPercent := ReadInteger(dSec, '3D height', 45);
        C.BackImageMode := TTeeBackImageMode(
          ReadInteger(dSec, 'BackImage Mode', 0));
        C.Gradient.Visible := dBak = 1;
        C.Gradient.Direction := TGradientDirection(
          ReadInteger(dSec, 'Gradient Direction', 0));
        C.Color := TColor(ReadInteger(dSec, 'Solid Color',
          Integer(clSilver)));
        // Note reversal of start and end colors
        C.Gradient.StartColor := TColor(ReadInteger(dSec,
          'Gradient End Color', Integer(clNavy)));
        C.Gradient.EndColor := TColor(ReadInteger(dSec,
          'Gradient Start Color', Integer(clAqua)));
        N := 0;
        dCols.Clear;
        WHILE True DO
          begin
            Col := ReadInteger(dSec+' Colors',
              Format('Color%.02d', [N]), -1);
            IF Col = -1 THEN Break;
            dCols.AddObject(IntToStr(Succ(N)), Pointer(Col));
            Inc(N);
          end;
        IF dCols.Count = 0 THEN
          FOR N := 0 TO MaxDefaultColors-1 DO
            dCols.AddObject(IntToStr(Succ(N)),
              Pointer(GetDefaultColor(N)));
      finally
        Free;
      end;
      IF First THEN
        begin
          C.RemoveAllSeries;
          C.Title.Text.Clear;
          C.Foot.Text.Clear;
          C.Title.Text.Add('DiskPie');
          fSR := TPieSeries.Create(Self);
          fSR.Circled := dCircled;
          fSR.Marks.Visible := dLabels;
          fSR.AddPie(0, '', TColor(dCols.Objects[0]));
          fSR.ParentChart := C;
          C.View3DOptions.Elevation := dElev;
        end
      ELSE
        begin
          fSR := TPieSeries(C.Series[0]);
          fSR.Circled := dCircled;
          fSR.Marks.Visible := dLabels;
          C.View3DOptions.Elevation := dElev;
          FOR N := 0 TO fSR.Count-1 DO
            fSR.ValueColor[N] :=
              TColor(dCols.Objects[N MOD dCols.Count]);
        end;
    end;
end;


procedure TMainForm.SavePie(C : TChart; const pieXtra : TChartExtra);
VAR N : Integer;
begin
  WITH TIniFile.Create(ininame), pieXtra DO
  try
    WriteString(dSec+' font', 'Name', C.Title.Font.Name);
    WriteInteger(dSec+' font', 'Size', C.Title.Font.Size);
    WriteInteger(dSec+' font', 'Style', Byte(C.Title.Font.Style));
    WriteInteger(dSec+' font', 'Color', Integer(C.Title.Font.Color));
    WriteBool(dSec, 'Circled pie', dCircled);
    WriteBool(dSec, '3D pie', C.View3D);
    WriteBool(dSec, 'Labels', dLabels);
    WriteBool(dSec, 'Legend', C.Legend.Visible);
    WriteBool(dSec, 'Scrollbars', dScroll);
    WriteInteger(dSec, '3D elevation', C.View3DOptions.Elevation);
    WriteInteger(dSec, '3D height', C.Chart3DPercent);
    WriteInteger(dSec, 'Slices', dSlices);
    WriteString(dSec, 'BackImage file', dImage);
    WriteInteger(dSec, 'BackImage Mode', Integer(C.BackImageMode));
    WriteInteger(dSec, 'Background Style', dbak);
    WriteInteger(dSec, 'Gradient Direction',
      Integer(C.Gradient.Direction));
    WriteInteger(dSec, 'Solid Color', Integer(C.Color));
    WriteInteger(dSec, 'Gradient End Color',
      Integer(C.Gradient.StartColor));
    WriteInteger(dSec, 'Gradient Start Color',
      Integer(C.Gradient.EndColor));
    EraseSection(dSec+' Colors');
    FOR N := 0 TO dCols.Count-1 DO
      WriteInteger(dSec+' Colors', Format('Color%.02d', [N]),
        Integer(dCols.Objects[N]));
  finally
    Free;
  end;
end;

function iComp(List: TStringList; Index1, Index2: Integer): Integer;
VAR I1, I2 : Int64;
begin
  I1 := TUobj(List.Objects[Index1]).Value;
  I2 := TUobj(List.Objects[Index2]).Value;
  IF I1 < I2 THEN Result := 1
  ELSE IF I1 > I2 THEN Result := -1
  ELSE Result := 0;
end;

procedure TMainForm.BakeFolderPie(const fName : String);
VAR
  fSR : TPieSeries;
  TN : TDPNode;
  I : Int64;
  N : Integer;
begin
  SetBusy(True);
  TN := TDT.NodeForPath(fName);
  IF TN = nil THEN Exit;
  chFolders.RemoveAllSeries;
  chFolders.Title.Text.Clear;
  chFolders.Foot.Text.Clear;
  chFolders.Title.Text.Add('One moment please...');
  chFolders.Repaint;
  fSR := TPieSeries.Create(Self);
  fSR.Circled := folXtra.dCircled;
  fSR.Marks.Visible := folXtra.dLabels;
  fSR.ParentChart := chFolders;
  chFolders.View3DOptions.Elevation := folXtra.dElev;
  fSR.AddPie(1, '', clGray);
  fSR.AddPie(0, '', clBlack);
  fSR.ShowInLegend := False;
  fSR.Marks.Visible := False;
  fSR.RotationAngle := 90;
  tmrFol.Enabled := True;
  tmrFol.Tag := 1; //2.1
  try
    TN.Expand;
    IF Halting THEN
      begin
        SetBusy(False);
        pcMain.ActivePageIndex := 0;
        Halting := False;
        folXtra.dTitle := '';
        TN.NoSize; 
        Exit;
      end;
    folXtra.dList.Clear;
    folXtra.dFilList.Clear;
    Screen.Cursor := crHourglass;
    try
      TN.GetSize;
      IF Halting THEN
        begin
          SetBusy(False);
          pcMain.ActivePageIndex := 0;
          Halting := False;
          folXtra.dTitle := '';
          TN.NoSize;
          Exit;
        end;
      // Get largest files
      TN.LargestFiles(folXtra.dFilList);
      // Add folder information
      FOR N := 0 TO TN.Count-1 DO
        folXtra.dList.AddObject(TN.Children[N].Name,
          TUobj.Create(TN.Children[N].GetSize));
      // Add "in folder", if appropriate
      IF TN.InSize > 0 THEN
        folXtra.dList.AddObject('"In folder"',
          TUObj.Create(TN.InSize));
      // Sort in reverse size order
      folXtra.dList.CustomSort(icomp);
      // IF more than uttermax, combine last into "Other"
      IF folXtra.dList.Count > uttermax THEN
        begin
          I := 0;
          FOR N := folXtra.dList.Count-1 DOWNTO Pred(UtterMax) DO
            begin
              I := I + TUObj(folXtra.dList.Objects[N]).Value;
              folXtra.dList.Delete(N);
            end;
          folXtra.dList.AddObject('"Other"', TUobj.Create(I));
        end;
      tmrFol.Tag := 0; //2.1
      tmrFol.Enabled := False;
      chFolders.RemoveAllSeries;
      fSR := TPieSeries.Create(Self);
      fSR.Circled := folXtra.dCircled;
      fSR.Marks.Visible := folXtra.dLabels;
      fSR.ParentChart := chFolders;
      chFolders.View3DOptions.Elevation := folXtra.dElev;
      ListToSeries(folXtra.dList, folXtra.dCols, fSR, folXtra.dSlices);
    finally
      Screen.Cursor := crDefault;
    end;
  finally
    tmrFol.Tag := 0; //2.1
    tmrFol.Enabled := False;
  end;
  folXtra.dTitle := fName;
  SetTheTitle(chFolders, folXtra.dTitle);
  IF (folXtra.dList.Count = 0) OR (fSR.PieValues[0] = 0) THEN
    begin
      fSR.Clear;
      chFolders.Foot.Text.Add('No non-empty files in folder.');
      chFolders.Repaint;
      MessageBeep(MB_ICONSTOP);
    end;
  TopEllipse(chFolders, folXtra.dRgn);
  SetBusy(False);
end;

procedure TMainform.BakeTypePie(const fName : String);
VAR
  fSR : TPieSeries;
  DTO : TDPTypeObj;
begin
  SetBusy(True);
  DTO := TDPTypeObj.Create;
  chTypes.RemoveAllSeries;
  chTypes.Title.Text.Clear;
  chTypes.Foot.Text.Clear;
  chTypes.Title.Text.Add('One moment please...');
  chTypes.Repaint;
  fSR := TPieSeries.Create(Self);
  fSR.Circled := typXtra.dCircled;
  fSR.Marks.Visible := typXtra.dLabels;
  fSR.ParentChart := chTypes;
  chTypes.View3DOptions.Elevation := typXtra.dElev;
  fSR.AddPie(1, '', clGray);
  fSR.AddPie(0, '', clBlack);
  fSR.ShowInLegend := False;
  fSR.Marks.Visible := False;
  fSR.RotationAngle := 90;
  tmrTyp.Tag := 1; //2.1
  tmrTyp.Enabled := True;
  try
    Screen.Cursor := crHourglass;
    DTO.AnalyzePath(fName);
    IF Halting THEN
      begin
        SetBusy(False);
        pcMain.ActivePageIndex := 0;
        Halting := False;
        folXtra.dTitle := '';
        Exit;
      end;
    typXtra.dList.Clear;
    try
      DTO.ShowHogs(typXtra.dList, UtterMax);
      DTO.LargestFiles(typXtra.dFilList);
      tmrTyp.Tag := 0; //2.1
      tmrTyp.Enabled := False;
      chTypes.RemoveAllSeries;
      fSR := TPieSeries.Create(Self);
      fSR.Circled := typXtra.dCircled;
      fSR.Marks.Visible := typXtra.dLabels;
      fSR.ParentChart := chTypes;
      chTypes.View3DOptions.Elevation := typXtra.dElev;
      ListToSeries(typXtra.dList, typXtra.dCols, fSR, typXtra.dSlices);
      IF typXtra.dList.Count = 0 THEN
        begin
          chTypes.Foot.Text.Add('No non-empty files in folder');
          chTypes.Repaint;
          MessageBeep(MB_ICONSTOP);
        end;
    finally
      Screen.Cursor := crDefault;
    end;
  finally
    tmrTyp.Tag := 0; //2.1
    tmrTyp.Enabled := False;
  end;
  typXtra.dTitle := fName;
  SetTheTitle(chTypes, typXtra.dTitle);
  TopEllipse(chTypes, typXtra.dRgn);
  SetBusy(False);
end;

function TMainform.CanPie(const S : String): Boolean;
begin
  Result := (S <> '') AND (DirectoryExists(S));
end;

function TMainform.CanPieParent(const S: String): Boolean;
begin
  Result := (ExtractFileDir(S) <> S) AND
    CanPie(ExtractFileDir(S));
end;

procedure TMainform.SetTheTitle(C: TChart; const S: String);
// Set the chart title to the specified path, replacing parts
// with ellipsis ... if necessary
VAR W : Integer;
begin
  W := C.ClientWidth;
  C.Title.Text.Clear;
  Self.Canvas.Font := C.Title.Font;
  IF S = '' THEN
    C.Title.Text.Add('DiskPie')
  ELSE
    C.Title.Text.Add(MinimizeName(S, Self.Canvas, W));
  C.Repaint;
end;

procedure TMainform.SetBusy(Value: Boolean);
VAR Cur : TCursor;
begin
  Busy := Value;
  IF Busy THEN Cur := crHourglass
  ELSE         Cur := crDefault;
  Screen.Cursor     := Cur;
  ebAddress.Enabled := NOT Busy;
  ssTree.Enabled    := NOT Busy;
  acRefreshUpdate(acRefresh);
  acFolderPieUpdate(acFolderPie);
  acPieCustomUpdate(acPieCustom);
end;

procedure TMainForm.TopEllipse(C : TChart; VAR Rgn : HRgn);
// Calculate an elliptical region that represents the TOP of the
// specified 3D pie. It is used to work around an error in the
// TChart's CalcClickedPart() method
VAR
  TP      : TPieSeries;
  Elev    : Integer;
  AdjXRad : Integer;
  AdjYRad : Integer;
  AdjXCtr : Integer;
  AdjYCtr : Integer;
  Adj3D   : Integer;
begin
  IF C.SeriesCount > 0 THEN
    begin
      IF Rgn <> 0 THEN DeleteObject(Rgn);
      TP      := TPieSeries(C.Series[0]);
      Elev    := C.View3DOptions.Elevation;
      AdjXRad := Round(TP.XRadius*C.View3DOptions.Zoom/100);
      AdjYRad := Round(Cos((Elev*pi)/180)*TP.YRadius*
        C.View3DOptions.Zoom/100);
      Adj3D := Round((-Sin((Elev*pi)/180))*C.Width3D*
        C.View3DOptions.Zoom/200);
      AdjYCtr := C.ChartYCenter - Adj3D + C.View3DOptions.VertOffset;
      AdjXCtr := C.ChartXCenter + C.View3DOptions.HorizOffset;
      Rgn := CreateEllipticRgn(AdjXCtr-AdjXRad, AdjYCtr-AdjYRad,
        AdjXCtr+AdjXRad, AdjYCtr+AdjYRad);
    end;
end;

procedure TMainform.ListToSeries(SL, SC: TStrings; SR: TPieSeries;
  slices: Integer);
// Take a list of pie-slice information and convert it to a pie
// series, possibly with fewer members
VAR
  N   : Integer;
  Num : Integer;
  I   : Int64;
begin
  SR.Clear;
  IF SL.Count > slices THEN
    begin
      I := 0;
      FOR N := slices-1 TO SL.Count-1 DO
        Inc(I, TUObj(SL.Objects[N]).Value);
      Num := slices;
    end
  ELSE
    begin
      I := -1;
      num := SL.Count;
    end;
  FOR N := 0 TO num-2 DO
    begin
      SR.AddPie(TUObj(SL.Objects[N]).Value, SL[N],
        TColor(SC.Objects[N MOD SC.Count]));
    end;
  N := num-1;
  IF N < 0 THEN Exit;
  IF I = -1 THEN
      SR.AddPie(TUObj(SL.Objects[N]).Value,
        SL[N], TColor(SC.Objects[N MOD SC.Count]))
  ELSE
      SR.AddPie(I, '"Other"',
        TColor(SC.Objects[N MOD SC.Count]));
end;

procedure TMainform.DefaultHandler(var Message);
// Respond to broadcast message indicating a customization change
begin
  inherited;
  WITH TMessage(Message) DO
    begin
      IF Msg <> CustomMsg THEN Exit;
      IF HWnd(wParam) = Self.Handle THEN Exit;
      CASE lParam OF
        1 : begin
          InitPie(false, chFolders, folXtra);
          acFolScroll.Checked := folXtra.dScroll;
          sbZoomF.Visible := popFolScroll.Checked;
          sbRotateF.Visible := popFolScroll.Checked;
          sbXOffF.Visible := popFolScroll.Checked;
          sbYOffF.Visible := popFolScroll.Checked;
          TopEllipse(chFolders, folXtra.dRgn);
        end;
        2 : begin
          InitPie(false, chTypes, typXtra);
          acTypScroll.Checked := typXtra.dScroll;
          sbZoomT.Visible := popTypScroll.Checked;
          sbRotateT.Visible := popTypScroll.Checked;
          sbXOffT.Visible := popTypScroll.Checked;
          sbYOffT.Visible := popTypScroll.Checked;
          TopEllipse(chTypes, typXtra.dRgn);
        end;
      END;
    end;
end;

end.

